<html>
<head>
<title>Ogre::Plugin Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1Plugin.html">Plugin</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::Plugin Class Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::Plugin" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>Class defining a generic OGRE plugin.  
 <a href="classOgre_1_1Plugin.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgrePlugin_8h_source.html">OgrePlugin.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::Plugin:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1Plugin__inherit__graph.gif" border="0" usemap="#Ogre_1_1Plugin_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1Plugin_inherit__map" id="Ogre_1_1Plugin_inherit__map">
<area shape="rect" id="node5" href="classOgre_1_1D3D11Plugin.html" title="Plugin instance for D3D11 Manager." alt="" coords="5,160,139,189"/><area shape="rect" id="node7" href="classOgre_1_1D3D9Plugin.html" title="Plugin instance for D3D9 Manager." alt="" coords="163,160,291,189"/><area shape="rect" id="node9" href="classOgre_1_1GLES2Plugin.html" title="Plugin instance for GL ES 2 Manager." alt="" coords="315,160,451,189"/><area shape="rect" id="node11" href="classOgre_1_1GLESPlugin.html" title="Plugin instance for GL Manager." alt="" coords="475,160,603,189"/><area shape="rect" id="node13" href="classOgre_1_1GLPlugin.html" title="Plugin instance for GL Manager." alt="" coords="627,160,736,189"/><area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="340,5,425,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1Plugin-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#a02890fc726dd3163721bdbec1c60339a">Plugin</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#a8f531cb7678768d34140e1aa15335f57">~Plugin</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#a25a8ef68cc19a03260696ce1c3d3d399">getName</a> () const =0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the name of the plugin.  <a href="#a25a8ef68cc19a03260696ce1c3d3d399"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#a556fd0c6a5a05cce82dc7df998c99c0f">install</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Perform the plugin initial installation sequence.  <a href="#a556fd0c6a5a05cce82dc7df998c99c0f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#a890da15775afd75c14e81bc6207de81f">initialise</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Perform any tasks the plugin needs to perform on full system initialisation.  <a href="#a890da15775afd75c14e81bc6207de81f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#a17fe6741c49a0fb9153797c70bdb884b">shutdown</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Perform any tasks the plugin needs to perform when the system is shut down.  <a href="#a17fe6741c49a0fb9153797c70bdb884b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Plugin.html#a47748105a90ce86b7e0f99a6910bd31d">uninstall</a> ()=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Perform the final plugin uninstallation sequence.  <a href="#a47748105a90ce86b7e0f99a6910bd31d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Class defining a generic OGRE plugin. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>OGRE is very plugin-oriented and you can customise much of its behaviour by registering new plugins, dynamically if you are using dynamic linking. This class abstracts the generic interface that all plugins must support. Within the implementations of this interface, the plugin must call other OGRE classes in order to register the detailed customisations it is providing, e.g. registering a new <a class="el" href="classOgre_1_1SceneManagerFactory.html" title="Class which will create instances of a given SceneManager.">SceneManagerFactory</a>, a new <a class="el" href="classOgre_1_1MovableObjectFactory.html" title="Interface definition for a factory class which produces a certain kind of MovableObject, and can be registered with Root in order to allow all clients to produce new instances of this object, integrated with the standard Ogre processing.">MovableObjectFactory</a>, or a new <a class="el" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>Plugins can be linked statically or dynamically. If they are linked dynamically (ie the plugin is in a DLL or Shared Object file), then you load the plugin by calling the <a class="el" href="classOgre_1_1Root.html#af0744e85bddb05885a91809bcdf8f864" title="Manually load a Plugin contained in a DLL / DSO.">Root::loadPlugin</a> method (or some other mechanism which leads to that call, e.g. plugins.cfg), passing the name of the DLL. OGRE will then call a global init function on that DLL, and it will be expected to register one or more <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> implementations using <a class="el" href="classOgre_1_1Root.html#a5ea47cd9c094644e1abac7607e1922fd" title="Install a new plugin.">Root::installPlugin</a>. The procedure is very similar if you use a static linked plugin, except that you simply instantiate the <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> implementation yourself and pass it to <a class="el" href="classOgre_1_1Root.html#a5ea47cd9c094644e1abac7607e1922fd" title="Install a new plugin.">Root::installPlugin</a>. </dd></dl>
<dl class="note"><dt><b>Note:</b></dt><dd>Lifecycle of a <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> instance is very important. The <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> instance must remain valid until the <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> is uninstalled. Here are the things you must bear in mind: <ul>
<li>
If your plugin is in a DLL: <ul>
<li>
Create the <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> instance and call <a class="el" href="classOgre_1_1Root.html#a5ea47cd9c094644e1abac7607e1922fd" title="Install a new plugin.">Root::installPlugin</a> in dllStartPlugin </li>
<li>
Call <a class="el" href="classOgre_1_1Root.html#a23417d6cbe7aeeafcc6a1a146a5e7b95" title="Uninstall an existing plugin.">Root::uninstallPlugin</a>, then delete it in dllStopPlugin</li>
</ul>
</li>
<li>
If your plugin is statically linked in your app: <ul>
<li>
Create the <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> anytime you like </li>
<li>
Call <a class="el" href="classOgre_1_1Root.html#a5ea47cd9c094644e1abac7607e1922fd" title="Install a new plugin.">Root::installPlugin</a> any time whilst <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a> is valid </li>
<li>
Call <a class="el" href="classOgre_1_1Root.html#a23417d6cbe7aeeafcc6a1a146a5e7b95" title="Uninstall an existing plugin.">Root::uninstallPlugin</a> if you like so long as <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a> is valid. However, it will be done for you when <a class="el" href="classOgre_1_1Root.html" title="The root class of the Ogre system.">Root</a> is destroyed, so the <a class="el" href="classOgre_1_1Plugin.html" title="Class defining a generic OGRE plugin.">Plugin</a> instance must still be valid at that point if you haven't manually uninstalled it.</li>
</ul>
</li>
</ul>
The install and uninstall methods will be called when the plugin is installed or uninstalled. The initialise and shutdown will be called when there is a system initialisation or shutdown, e.g. when <a class="el" href="classOgre_1_1Root.html#ab940f0e3b8bff37feb0987c8b3e128b5" title="Initialises the renderer.">Root::initialise</a> or <a class="el" href="classOgre_1_1Root.html#adc677530cc7ef50fbd0e37d75c02e16b" title="Shuts down the system manually.">Root::shutdown</a> are called. </dd></dl>

<p>Definition at line <a class="el" href="OgrePlugin_8h_source.html#l00079">79</a> of file <a class="el" href="OgrePlugin_8h_source.html">OgrePlugin.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a02890fc726dd3163721bdbec1c60339a"></a><!-- doxytag: member="Ogre::Plugin::Plugin" ref="a02890fc726dd3163721bdbec1c60339a" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Plugin.html#a02890fc726dd3163721bdbec1c60339a">Ogre::Plugin::Plugin</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePlugin_8h_source.html#l00082">82</a> of file <a class="el" href="OgrePlugin_8h_source.html">OgrePlugin.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8f531cb7678768d34140e1aa15335f57"></a><!-- doxytag: member="Ogre::Plugin::~Plugin" ref="a8f531cb7678768d34140e1aa15335f57" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1Plugin.html#a8f531cb7678768d34140e1aa15335f57">Ogre::Plugin::~Plugin</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgrePlugin_8h_source.html#l00083">83</a> of file <a class="el" href="OgrePlugin_8h_source.html">OgrePlugin.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a25a8ef68cc19a03260696ce1c3d3d399"></a><!-- doxytag: member="Ogre::Plugin::getName" ref="a25a8ef68cc19a03260696ce1c3d3d399" args="() const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1Plugin.html#a25a8ef68cc19a03260696ce1c3d3d399">Ogre::Plugin::getName</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the name of the plugin. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>An implementation must be supplied for this method to uniquely identify the plugin. </dd></dl>

<p>Implemented in <a class="el" href="classOgre_1_1GLESPlugin.html#a6622f2586322b34bf615d36776b05ed0">Ogre::GLESPlugin</a>, <a class="el" href="classOgre_1_1D3D11Plugin.html#ab36b169812306403d75b7bc899035eef">Ogre::D3D11Plugin</a>, <a class="el" href="classOgre_1_1D3D9Plugin.html#ad4ad54131a771e16e7e7173371e52f60">Ogre::D3D9Plugin</a>, <a class="el" href="classOgre_1_1GLPlugin.html#a11a97d634ff5d1ee296b34d8c1d95d83">Ogre::GLPlugin</a>, and <a class="el" href="classOgre_1_1GLES2Plugin.html#a3aca87457d7468f436a68a4cbbaf287d">Ogre::GLES2Plugin</a>.</p>

</div>
</div>
<a class="anchor" id="a890da15775afd75c14e81bc6207de81f"></a><!-- doxytag: member="Ogre::Plugin::initialise" ref="a890da15775afd75c14e81bc6207de81f" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1Plugin.html#a890da15775afd75c14e81bc6207de81f">Ogre::Plugin::initialise</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Perform any tasks the plugin needs to perform on full system initialisation. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>An implementation must be supplied for this method. It is called just after the system is fully initialised (either after <a class="el" href="classOgre_1_1Root.html#ab940f0e3b8bff37feb0987c8b3e128b5" title="Initialises the renderer.">Root::initialise</a> if a window is created then, or after the first window is created) and therefore all rendersystem functionality is available at this time. You can use this hook to create any resources which are dependent on a rendersystem or have rendersystem-specific implementations. </dd></dl>

<p>Implemented in <a class="el" href="classOgre_1_1GLESPlugin.html#a9215466b1788f40afa9606b9f611142a">Ogre::GLESPlugin</a>, <a class="el" href="classOgre_1_1D3D11Plugin.html#a456b2be12aea02c4b5c7de2570da8333">Ogre::D3D11Plugin</a>, <a class="el" href="classOgre_1_1D3D9Plugin.html#a8946e752e2dcd9d4047d43020607babb">Ogre::D3D9Plugin</a>, <a class="el" href="classOgre_1_1GLPlugin.html#a99da304c6ca47a79f141f4f4be047009">Ogre::GLPlugin</a>, and <a class="el" href="classOgre_1_1GLES2Plugin.html#abc32f9504be080a8d866bc5b24a95851">Ogre::GLES2Plugin</a>.</p>

</div>
</div>
<a class="anchor" id="a556fd0c6a5a05cce82dc7df998c99c0f"></a><!-- doxytag: member="Ogre::Plugin::install" ref="a556fd0c6a5a05cce82dc7df998c99c0f" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1Plugin.html#a556fd0c6a5a05cce82dc7df998c99c0f">Ogre::Plugin::install</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Perform the plugin initial installation sequence. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>An implementation must be supplied for this method. It must perform the startup tasks necessary to install any rendersystem customisations or anything else that is not dependent on system initialisation, ie only dependent on the core of <a class="el" href="namespaceOgre.html">Ogre</a>. It must not perform any operations that would create rendersystem-specific objects at this stage, that should be done in <a class="el" href="classOgre_1_1Plugin.html#a890da15775afd75c14e81bc6207de81f" title="Perform any tasks the plugin needs to perform on full system initialisation.">initialise()</a>. </dd></dl>

<p>Implemented in <a class="el" href="classOgre_1_1GLESPlugin.html#a73dfdc9b632be4e89ae43d13a37df608">Ogre::GLESPlugin</a>, <a class="el" href="classOgre_1_1D3D11Plugin.html#adab23d0c7b46a1edca177b0d2a36da3f">Ogre::D3D11Plugin</a>, <a class="el" href="classOgre_1_1D3D9Plugin.html#ac36cae5597f61ed2b8f694c23cbac4a8">Ogre::D3D9Plugin</a>, <a class="el" href="classOgre_1_1GLPlugin.html#a29440516506cf58b40e5731cb887a121">Ogre::GLPlugin</a>, and <a class="el" href="classOgre_1_1GLES2Plugin.html#a11a9f8b3a25c275d1d35b2a9db5f0ac6">Ogre::GLES2Plugin</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::Plugin::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::Plugin::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::Plugin::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::Plugin::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::Plugin::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::Plugin::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::Plugin::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::Plugin::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::Plugin::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::Plugin::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a17fe6741c49a0fb9153797c70bdb884b"></a><!-- doxytag: member="Ogre::Plugin::shutdown" ref="a17fe6741c49a0fb9153797c70bdb884b" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1Plugin.html#a17fe6741c49a0fb9153797c70bdb884b">Ogre::Plugin::shutdown</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Perform any tasks the plugin needs to perform when the system is shut down. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>An implementation must be supplied for this method. This method is called just before key parts of the system are unloaded, such as rendersystems being shut down. You should use this hook to free up resources and decouple custom objects from the OGRE system, whilst all the instances of other plugins (e.g. rendersystems) still exist. </dd></dl>

<p>Implemented in <a class="el" href="classOgre_1_1GLESPlugin.html#a45d83a0fc6a1effa280d71be4f5d4922">Ogre::GLESPlugin</a>, <a class="el" href="classOgre_1_1D3D11Plugin.html#a9759f24b9afcb50ab23ad7f7449ce479">Ogre::D3D11Plugin</a>, <a class="el" href="classOgre_1_1D3D9Plugin.html#ae6dade3a09bae91b9e1a1f18d3bc2c7e">Ogre::D3D9Plugin</a>, <a class="el" href="classOgre_1_1GLPlugin.html#a519863fd21904a777870764ef58da54f">Ogre::GLPlugin</a>, and <a class="el" href="classOgre_1_1GLES2Plugin.html#a4acd95b74d4e842b14acef1ff0d655f8">Ogre::GLES2Plugin</a>.</p>

</div>
</div>
<a class="anchor" id="a47748105a90ce86b7e0f99a6910bd31d"></a><!-- doxytag: member="Ogre::Plugin::uninstall" ref="a47748105a90ce86b7e0f99a6910bd31d" args="()=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1Plugin.html#a47748105a90ce86b7e0f99a6910bd31d">Ogre::Plugin::uninstall</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Perform the final plugin uninstallation sequence. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>An implementation must be supplied for this method. It must perform the cleanup tasks which haven't already been performed in <a class="el" href="classOgre_1_1Plugin.html#a17fe6741c49a0fb9153797c70bdb884b" title="Perform any tasks the plugin needs to perform when the system is shut down.">shutdown()</a> (e.g. final deletion of custom instances, if you kept them around incase the system was reinitialised). At this stage you cannot be sure what other plugins are still loaded or active. It must therefore not perform any operations that would reference any rendersystem-specific objects - those should have been sorted out in the 'shutdown' method. </dd></dl>

<p>Implemented in <a class="el" href="classOgre_1_1GLESPlugin.html#a99346269681ced5a5f803ddff90fa441">Ogre::GLESPlugin</a>, <a class="el" href="classOgre_1_1D3D11Plugin.html#a616d9c96c8120f9a7471a2ee303bc60a">Ogre::D3D11Plugin</a>, <a class="el" href="classOgre_1_1D3D9Plugin.html#a3c2122a93a37dc80714f8929f3201b23">Ogre::D3D9Plugin</a>, <a class="el" href="classOgre_1_1GLPlugin.html#a9c2f7b5f7f802edb13989e2a3b63dc8b">Ogre::GLPlugin</a>, and <a class="el" href="classOgre_1_1GLES2Plugin.html#a204d59b3c13f941c1b72ba2ce1c4b408">Ogre::GLES2Plugin</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgrePlugin_8h_source.html">OgrePlugin.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:02
</p>
</body>
</html>
